%% SIDLOC - Requirements Tables
%% Copyright (C) 2021, 2022 Libre Space Foundation
%%
%% This work is licensed under a
%% Creative Commons Attribution-ShareAlike 4.0 International License.
%%
%% You should have received a copy of the license along with this
%% work.  If not, see <http://creativecommons.org/licenses/by-sa/4.0/>.

{%- set categories = [
  'Specification',
  'Experiment',
]
%}
{%- set types = [
  'Communications',
  'Configuration',
  'Design',
  'Functional',
  'Interface',
  'Operational',
  'Performance',
  'Regulatory',
]
%}
{%- set compliance = [
  'Compliance::Full',
  'Compliance::Partial',
  'Compliance::None',
  'Compliance::Not Applicable',
]
%}
{%- set compliance_ariane_6 = [
  'Compliance Ariane 6::Full',
  'Compliance Ariane 6::Partial',
  'Compliance Ariane 6::None',
  'Compliance Ariane 6::Not Applicable',
]
%}

\providecommand{\tightlist}{
\setlength{\itemsep}{0pt}\setlength{\parskip}{0pt}}

{% for category in categories -%}
{% for type in types %}
\newcommand{\{{ (category ~ type) | replace(' ', '') }}}{
{% for item in issues if type in item.labels if category in item.labels %}
  \addcontentsline{toc}{subsection}{REQ-{{ item.id }} --- {{ item.title | md2tex | trim }}}

  \begin{table}[ht]
    \centering
    \begin{tabular}{lp{0.6\linewidth}}
      \toprule
      \textbf{ID} &
                    \bfseries
                    REQ-{{ item.id }} --- {{ item.title | md2tex | trim }}
      \\ \midrule
      \textbf{Type} &
                      {{ item.labels|select('in', types + categories)|join(', ') }}
      \\ \midrule
      \textbf{Description} &
                             {{ item.content.Description | md2tex | trim  }}
      \\ \midrule
      \textbf{Rationale} &
                           {{ item.content.Rationale | md2tex | trim  }}
      \\ \bottomrule
    \end{tabular}
  \end{table}
{% endfor %}
}
{% endfor %}
{% endfor %}

\newcommand{\reqmatrix}{
{%- for item in issues %}
  \reqcomprec{{ '{' }}{{item.id}}}{{ '{' }}{{ item.labels | select('in', compliance) | first | replace('Compliance::', '') }}}{{ '{' }}{{ item.content['Design Compliance Comment'] }}}
  \\ {% if not loop.last %}\midrule{% else %}\bottomrule{% endif %}
{%- endfor %}
}

\newcommand{\reqmatrixariane}{
{%- for item in issues %}
  \reqcomprec{{ '{' }}{{item.id}}}{{ '{' }}{{ item.labels | select('in', compliance_ariane_6) | first | replace('Compliance Ariane 6::', '') }}}{{ '{' }}{{ item.content['Ariane 6 Experiment Compliance Comment'] }}}
  \\ {% if not loop.last %}\midrule{% else %}\bottomrule{% endif %}
{%- endfor %}
}
